/**
 * Copyright (c) 2017-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * @generated
 */

//
// Autogenerated by Thrift Compiler (0.11.0)
//
// DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
//
"use strict";

var thrift = require('thrift');
var Thrift = thrift.Thrift;
var Q = thrift.Q;


var ttypes = require('./filesystem_types');
//HELPER FUNCTIONS AND STRUCTURES

var ThriftFileSystemService_watch_args = function(args) {
  this.uri = null;
  this.options = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
    if (args.options !== undefined && args.options !== null) {
      this.options = new ttypes.WatchOpt(args.options);
    }
  }
};
ThriftFileSystemService_watch_args.prototype = {};
ThriftFileSystemService_watch_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 2:
      if (ftype == Thrift.Type.STRUCT) {
        this.options = new ttypes.WatchOpt();
        this.options.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_watch_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_watch_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  if (this.options !== null && this.options !== undefined) {
    output.writeFieldBegin('options', Thrift.Type.STRUCT, 2);
    this.options.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_watch_result = function(args) {
  this.success = null;
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.success !== undefined && args.success !== null) {
      this.success = args.success;
    }
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_watch_result.prototype = {};
ThriftFileSystemService_watch_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 0:
      if (ftype == Thrift.Type.STRING) {
        this.success = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_watch_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_watch_result');
  if (this.success !== null && this.success !== undefined) {
    output.writeFieldBegin('success', Thrift.Type.STRING, 0);
    output.writeString(this.success);
    output.writeFieldEnd();
  }
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_unwatch_args = function(args) {
  this.watchId = null;
  if (args) {
    if (args.watchId !== undefined && args.watchId !== null) {
      this.watchId = args.watchId;
    }
  }
};
ThriftFileSystemService_unwatch_args.prototype = {};
ThriftFileSystemService_unwatch_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.watchId = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_unwatch_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_unwatch_args');
  if (this.watchId !== null && this.watchId !== undefined) {
    output.writeFieldBegin('watchId', Thrift.Type.STRING, 1);
    output.writeString(this.watchId);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_unwatch_result = function(args) {
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_unwatch_result.prototype = {};
ThriftFileSystemService_unwatch_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_unwatch_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_unwatch_result');
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_pollFileChanges_args = function(args) {
  this.watchId = null;
  if (args) {
    if (args.watchId !== undefined && args.watchId !== null) {
      this.watchId = args.watchId;
    }
  }
};
ThriftFileSystemService_pollFileChanges_args.prototype = {};
ThriftFileSystemService_pollFileChanges_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.watchId = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_pollFileChanges_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_pollFileChanges_args');
  if (this.watchId !== null && this.watchId !== undefined) {
    output.writeFieldBegin('watchId', Thrift.Type.STRING, 1);
    output.writeString(this.watchId);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_pollFileChanges_result = function(args) {
  this.success = null;
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.success !== undefined && args.success !== null) {
      this.success = Thrift.copyList(args.success, [ttypes.FileChangeEvent]);
    }
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_pollFileChanges_result.prototype = {};
ThriftFileSystemService_pollFileChanges_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 0:
      if (ftype == Thrift.Type.LIST) {
        var _size8 = 0;
        var _rtmp312;
        this.success = [];
        var _etype11 = 0;
        _rtmp312 = input.readListBegin();
        _etype11 = _rtmp312.etype;
        _size8 = _rtmp312.size;
        for (var _i13 = 0; _i13 < _size8; ++_i13)
        {
          var elem14 = null;
          elem14 = new ttypes.FileChangeEvent();
          elem14.read(input);
          this.success.push(elem14);
        }
        input.readListEnd();
      } else {
        input.skip(ftype);
      }
      break;
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_pollFileChanges_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_pollFileChanges_result');
  if (this.success !== null && this.success !== undefined) {
    output.writeFieldBegin('success', Thrift.Type.LIST, 0);
    output.writeListBegin(Thrift.Type.STRUCT, this.success.length);
    for (var iter15 in this.success)
    {
      if (this.success.hasOwnProperty(iter15))
      {
        iter15 = this.success[iter15];
        iter15.write(output);
      }
    }
    output.writeListEnd();
    output.writeFieldEnd();
  }
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_stat_args = function(args) {
  this.uri = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
  }
};
ThriftFileSystemService_stat_args.prototype = {};
ThriftFileSystemService_stat_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_stat_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_stat_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_stat_result = function(args) {
  this.success = null;
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.success !== undefined && args.success !== null) {
      this.success = new ttypes.FileStat(args.success);
    }
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_stat_result.prototype = {};
ThriftFileSystemService_stat_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 0:
      if (ftype == Thrift.Type.STRUCT) {
        this.success = new ttypes.FileStat();
        this.success.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_stat_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_stat_result');
  if (this.success !== null && this.success !== undefined) {
    output.writeFieldBegin('success', Thrift.Type.STRUCT, 0);
    this.success.write(output);
    output.writeFieldEnd();
  }
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_lstat_args = function(args) {
  this.uri = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
  }
};
ThriftFileSystemService_lstat_args.prototype = {};
ThriftFileSystemService_lstat_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_lstat_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_lstat_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_lstat_result = function(args) {
  this.success = null;
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.success !== undefined && args.success !== null) {
      this.success = new ttypes.FileStat(args.success);
    }
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_lstat_result.prototype = {};
ThriftFileSystemService_lstat_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 0:
      if (ftype == Thrift.Type.STRUCT) {
        this.success = new ttypes.FileStat();
        this.success.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_lstat_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_lstat_result');
  if (this.success !== null && this.success !== undefined) {
    output.writeFieldBegin('success', Thrift.Type.STRUCT, 0);
    this.success.write(output);
    output.writeFieldEnd();
  }
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_readDirectory_args = function(args) {
  this.uri = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
  }
};
ThriftFileSystemService_readDirectory_args.prototype = {};
ThriftFileSystemService_readDirectory_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_readDirectory_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_readDirectory_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_readDirectory_result = function(args) {
  this.success = null;
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.success !== undefined && args.success !== null) {
      this.success = Thrift.copyList(args.success, [ttypes.FileEntry]);
    }
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_readDirectory_result.prototype = {};
ThriftFileSystemService_readDirectory_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 0:
      if (ftype == Thrift.Type.LIST) {
        var _size16 = 0;
        var _rtmp320;
        this.success = [];
        var _etype19 = 0;
        _rtmp320 = input.readListBegin();
        _etype19 = _rtmp320.etype;
        _size16 = _rtmp320.size;
        for (var _i21 = 0; _i21 < _size16; ++_i21)
        {
          var elem22 = null;
          elem22 = new ttypes.FileEntry();
          elem22.read(input);
          this.success.push(elem22);
        }
        input.readListEnd();
      } else {
        input.skip(ftype);
      }
      break;
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_readDirectory_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_readDirectory_result');
  if (this.success !== null && this.success !== undefined) {
    output.writeFieldBegin('success', Thrift.Type.LIST, 0);
    output.writeListBegin(Thrift.Type.STRUCT, this.success.length);
    for (var iter23 in this.success)
    {
      if (this.success.hasOwnProperty(iter23))
      {
        iter23 = this.success[iter23];
        iter23.write(output);
      }
    }
    output.writeListEnd();
    output.writeFieldEnd();
  }
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_createDirectory_args = function(args) {
  this.uri = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
  }
};
ThriftFileSystemService_createDirectory_args.prototype = {};
ThriftFileSystemService_createDirectory_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_createDirectory_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_createDirectory_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_createDirectory_result = function(args) {
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_createDirectory_result.prototype = {};
ThriftFileSystemService_createDirectory_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_createDirectory_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_createDirectory_result');
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_readFile_args = function(args) {
  this.uri = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
  }
};
ThriftFileSystemService_readFile_args.prototype = {};
ThriftFileSystemService_readFile_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_readFile_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_readFile_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_readFile_result = function(args) {
  this.success = null;
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.success !== undefined && args.success !== null) {
      this.success = args.success;
    }
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_readFile_result.prototype = {};
ThriftFileSystemService_readFile_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 0:
      if (ftype == Thrift.Type.STRING) {
        this.success = input.readBinary();
      } else {
        input.skip(ftype);
      }
      break;
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_readFile_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_readFile_result');
  if (this.success !== null && this.success !== undefined) {
    output.writeFieldBegin('success', Thrift.Type.STRING, 0);
    output.writeBinary(this.success);
    output.writeFieldEnd();
  }
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_writeFile_args = function(args) {
  this.uri = null;
  this.content = null;
  this.options = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
    if (args.content !== undefined && args.content !== null) {
      this.content = args.content;
    }
    if (args.options !== undefined && args.options !== null) {
      this.options = new ttypes.WriteFileOpt(args.options);
    }
  }
};
ThriftFileSystemService_writeFile_args.prototype = {};
ThriftFileSystemService_writeFile_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 2:
      if (ftype == Thrift.Type.STRING) {
        this.content = input.readBinary();
      } else {
        input.skip(ftype);
      }
      break;
      case 3:
      if (ftype == Thrift.Type.STRUCT) {
        this.options = new ttypes.WriteFileOpt();
        this.options.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_writeFile_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_writeFile_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  if (this.content !== null && this.content !== undefined) {
    output.writeFieldBegin('content', Thrift.Type.STRING, 2);
    output.writeBinary(this.content);
    output.writeFieldEnd();
  }
  if (this.options !== null && this.options !== undefined) {
    output.writeFieldBegin('options', Thrift.Type.STRUCT, 3);
    this.options.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_writeFile_result = function(args) {
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_writeFile_result.prototype = {};
ThriftFileSystemService_writeFile_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_writeFile_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_writeFile_result');
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_deletePath_args = function(args) {
  this.uri = null;
  this.options = null;
  if (args) {
    if (args.uri !== undefined && args.uri !== null) {
      this.uri = args.uri;
    }
    if (args.options !== undefined && args.options !== null) {
      this.options = new ttypes.DeleteOpt(args.options);
    }
  }
};
ThriftFileSystemService_deletePath_args.prototype = {};
ThriftFileSystemService_deletePath_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.uri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 2:
      if (ftype == Thrift.Type.STRUCT) {
        this.options = new ttypes.DeleteOpt();
        this.options.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_deletePath_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_deletePath_args');
  if (this.uri !== null && this.uri !== undefined) {
    output.writeFieldBegin('uri', Thrift.Type.STRING, 1);
    output.writeString(this.uri);
    output.writeFieldEnd();
  }
  if (this.options !== null && this.options !== undefined) {
    output.writeFieldBegin('options', Thrift.Type.STRUCT, 2);
    this.options.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_deletePath_result = function(args) {
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_deletePath_result.prototype = {};
ThriftFileSystemService_deletePath_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_deletePath_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_deletePath_result');
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_rename_args = function(args) {
  this.oldUri = null;
  this.newUri = null;
  this.options = null;
  if (args) {
    if (args.oldUri !== undefined && args.oldUri !== null) {
      this.oldUri = args.oldUri;
    }
    if (args.newUri !== undefined && args.newUri !== null) {
      this.newUri = args.newUri;
    }
    if (args.options !== undefined && args.options !== null) {
      this.options = new ttypes.RenameOpt(args.options);
    }
  }
};
ThriftFileSystemService_rename_args.prototype = {};
ThriftFileSystemService_rename_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.oldUri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 2:
      if (ftype == Thrift.Type.STRING) {
        this.newUri = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 3:
      if (ftype == Thrift.Type.STRUCT) {
        this.options = new ttypes.RenameOpt();
        this.options.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_rename_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_rename_args');
  if (this.oldUri !== null && this.oldUri !== undefined) {
    output.writeFieldBegin('oldUri', Thrift.Type.STRING, 1);
    output.writeString(this.oldUri);
    output.writeFieldEnd();
  }
  if (this.newUri !== null && this.newUri !== undefined) {
    output.writeFieldBegin('newUri', Thrift.Type.STRING, 2);
    output.writeString(this.newUri);
    output.writeFieldEnd();
  }
  if (this.options !== null && this.options !== undefined) {
    output.writeFieldBegin('options', Thrift.Type.STRUCT, 3);
    this.options.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_rename_result = function(args) {
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_rename_result.prototype = {};
ThriftFileSystemService_rename_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_rename_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_rename_result');
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_copy_args = function(args) {
  this.source = null;
  this.destination = null;
  this.options = null;
  if (args) {
    if (args.source !== undefined && args.source !== null) {
      this.source = args.source;
    }
    if (args.destination !== undefined && args.destination !== null) {
      this.destination = args.destination;
    }
    if (args.options !== undefined && args.options !== null) {
      this.options = new ttypes.CopyOpt(args.options);
    }
  }
};
ThriftFileSystemService_copy_args.prototype = {};
ThriftFileSystemService_copy_args.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRING) {
        this.source = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 2:
      if (ftype == Thrift.Type.STRING) {
        this.destination = input.readString();
      } else {
        input.skip(ftype);
      }
      break;
      case 3:
      if (ftype == Thrift.Type.STRUCT) {
        this.options = new ttypes.CopyOpt();
        this.options.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_copy_args.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_copy_args');
  if (this.source !== null && this.source !== undefined) {
    output.writeFieldBegin('source', Thrift.Type.STRING, 1);
    output.writeString(this.source);
    output.writeFieldEnd();
  }
  if (this.destination !== null && this.destination !== undefined) {
    output.writeFieldBegin('destination', Thrift.Type.STRING, 2);
    output.writeString(this.destination);
    output.writeFieldEnd();
  }
  if (this.options !== null && this.options !== undefined) {
    output.writeFieldBegin('options', Thrift.Type.STRUCT, 3);
    this.options.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemService_copy_result = function(args) {
  this.error = null;
  if (args instanceof ttypes.Error) {
    this.error = args;
    return;
  }
  if (args) {
    if (args.error !== undefined && args.error !== null) {
      this.error = args.error;
    }
  }
};
ThriftFileSystemService_copy_result.prototype = {};
ThriftFileSystemService_copy_result.prototype.read = function(input) {
  input.readStructBegin();
  while (true)
  {
    var ret = input.readFieldBegin();
    var fname = ret.fname;
    var ftype = ret.ftype;
    var fid = ret.fid;
    if (ftype == Thrift.Type.STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
      if (ftype == Thrift.Type.STRUCT) {
        this.error = new ttypes.Error();
        this.error.read(input);
      } else {
        input.skip(ftype);
      }
      break;
      case 0:
        input.skip(ftype);
        break;
      default:
        input.skip(ftype);
    }
    input.readFieldEnd();
  }
  input.readStructEnd();
  return;
};

ThriftFileSystemService_copy_result.prototype.write = function(output) {
  output.writeStructBegin('ThriftFileSystemService_copy_result');
  if (this.error !== null && this.error !== undefined) {
    output.writeFieldBegin('error', Thrift.Type.STRUCT, 1);
    this.error.write(output);
    output.writeFieldEnd();
  }
  output.writeFieldStop();
  output.writeStructEnd();
  return;
};

var ThriftFileSystemServiceClient = exports.Client = function(output, pClass) {
    this.output = output;
    this.pClass = pClass;
    this._seqid = 0;
    this._reqs = {};
};
ThriftFileSystemServiceClient.prototype = {};
ThriftFileSystemServiceClient.prototype.seqid = function() { return this._seqid; };
ThriftFileSystemServiceClient.prototype.new_seqid = function() { return this._seqid += 1; };
ThriftFileSystemServiceClient.prototype.watch = function(uri, options, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_watch(uri, options);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_watch(uri, options);
  }
};

ThriftFileSystemServiceClient.prototype.send_watch = function(uri, options) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('watch', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri,
    options: options
  };
  var args = new ThriftFileSystemService_watch_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_watch = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_watch_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  if (null !== result.success) {
    return callback(null, result.success);
  }
  return callback('watch failed: unknown result');
};
ThriftFileSystemServiceClient.prototype.unwatch = function(watchId, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_unwatch(watchId);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_unwatch(watchId);
  }
};

ThriftFileSystemServiceClient.prototype.send_unwatch = function(watchId) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('unwatch', Thrift.MessageType.CALL, this.seqid());
  var params = {
    watchId: watchId
  };
  var args = new ThriftFileSystemService_unwatch_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_unwatch = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_unwatch_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  callback(null);
};
ThriftFileSystemServiceClient.prototype.pollFileChanges = function(watchId, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_pollFileChanges(watchId);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_pollFileChanges(watchId);
  }
};

ThriftFileSystemServiceClient.prototype.send_pollFileChanges = function(watchId) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('pollFileChanges', Thrift.MessageType.CALL, this.seqid());
  var params = {
    watchId: watchId
  };
  var args = new ThriftFileSystemService_pollFileChanges_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_pollFileChanges = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_pollFileChanges_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  if (null !== result.success) {
    return callback(null, result.success);
  }
  return callback('pollFileChanges failed: unknown result');
};
ThriftFileSystemServiceClient.prototype.stat = function(uri, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_stat(uri);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_stat(uri);
  }
};

ThriftFileSystemServiceClient.prototype.send_stat = function(uri) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('stat', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri
  };
  var args = new ThriftFileSystemService_stat_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_stat = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_stat_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  if (null !== result.success) {
    return callback(null, result.success);
  }
  return callback('stat failed: unknown result');
};
ThriftFileSystemServiceClient.prototype.lstat = function(uri, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_lstat(uri);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_lstat(uri);
  }
};

ThriftFileSystemServiceClient.prototype.send_lstat = function(uri) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('lstat', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri
  };
  var args = new ThriftFileSystemService_lstat_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_lstat = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_lstat_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  if (null !== result.success) {
    return callback(null, result.success);
  }
  return callback('lstat failed: unknown result');
};
ThriftFileSystemServiceClient.prototype.readDirectory = function(uri, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_readDirectory(uri);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_readDirectory(uri);
  }
};

ThriftFileSystemServiceClient.prototype.send_readDirectory = function(uri) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('readDirectory', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri
  };
  var args = new ThriftFileSystemService_readDirectory_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_readDirectory = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_readDirectory_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  if (null !== result.success) {
    return callback(null, result.success);
  }
  return callback('readDirectory failed: unknown result');
};
ThriftFileSystemServiceClient.prototype.createDirectory = function(uri, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_createDirectory(uri);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_createDirectory(uri);
  }
};

ThriftFileSystemServiceClient.prototype.send_createDirectory = function(uri) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('createDirectory', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri
  };
  var args = new ThriftFileSystemService_createDirectory_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_createDirectory = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_createDirectory_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  callback(null);
};
ThriftFileSystemServiceClient.prototype.readFile = function(uri, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_readFile(uri);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_readFile(uri);
  }
};

ThriftFileSystemServiceClient.prototype.send_readFile = function(uri) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('readFile', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri
  };
  var args = new ThriftFileSystemService_readFile_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_readFile = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_readFile_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  if (null !== result.success) {
    return callback(null, result.success);
  }
  return callback('readFile failed: unknown result');
};
ThriftFileSystemServiceClient.prototype.writeFile = function(uri, content, options, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_writeFile(uri, content, options);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_writeFile(uri, content, options);
  }
};

ThriftFileSystemServiceClient.prototype.send_writeFile = function(uri, content, options) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('writeFile', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri,
    content: content,
    options: options
  };
  var args = new ThriftFileSystemService_writeFile_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_writeFile = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_writeFile_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  callback(null);
};
ThriftFileSystemServiceClient.prototype.deletePath = function(uri, options, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_deletePath(uri, options);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_deletePath(uri, options);
  }
};

ThriftFileSystemServiceClient.prototype.send_deletePath = function(uri, options) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('deletePath', Thrift.MessageType.CALL, this.seqid());
  var params = {
    uri: uri,
    options: options
  };
  var args = new ThriftFileSystemService_deletePath_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_deletePath = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_deletePath_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  callback(null);
};
ThriftFileSystemServiceClient.prototype.rename = function(oldUri, newUri, options, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_rename(oldUri, newUri, options);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_rename(oldUri, newUri, options);
  }
};

ThriftFileSystemServiceClient.prototype.send_rename = function(oldUri, newUri, options) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('rename', Thrift.MessageType.CALL, this.seqid());
  var params = {
    oldUri: oldUri,
    newUri: newUri,
    options: options
  };
  var args = new ThriftFileSystemService_rename_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_rename = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_rename_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  callback(null);
};
ThriftFileSystemServiceClient.prototype.copy = function(source, destination, options, callback) {
  this._seqid = this.new_seqid();
  if (callback === undefined) {
    var _defer = Q.defer();
    this._reqs[this.seqid()] = function(error, result) {
      if (error) {
        _defer.reject(error);
      } else {
        _defer.resolve(result);
      }
    };
    this.send_copy(source, destination, options);
    return _defer.promise;
  } else {
    this._reqs[this.seqid()] = callback;
    this.send_copy(source, destination, options);
  }
};

ThriftFileSystemServiceClient.prototype.send_copy = function(source, destination, options) {
  var output = new this.pClass(this.output);
  output.writeMessageBegin('copy', Thrift.MessageType.CALL, this.seqid());
  var params = {
    source: source,
    destination: destination,
    options: options
  };
  var args = new ThriftFileSystemService_copy_args(params);
  args.write(output);
  output.writeMessageEnd();
  return this.output.flush();
};

ThriftFileSystemServiceClient.prototype.recv_copy = function(input,mtype,rseqid) {
  var callback = this._reqs[rseqid] || function() {};
  delete this._reqs[rseqid];
  if (mtype == Thrift.MessageType.EXCEPTION) {
    var x = new Thrift.TApplicationException();
    x.read(input);
    input.readMessageEnd();
    return callback(x);
  }
  var result = new ThriftFileSystemService_copy_result();
  result.read(input);
  input.readMessageEnd();

  if (null !== result.error) {
    return callback(result.error);
  }
  callback(null);
};
var ThriftFileSystemServiceProcessor = exports.Processor = function(handler) {
  this._handler = handler;
}
;
ThriftFileSystemServiceProcessor.prototype.process = function(input, output) {
  var r = input.readMessageBegin();
  if (this['process_' + r.fname]) {
    return this['process_' + r.fname].call(this, r.rseqid, input, output);
  } else {
    input.skip(Thrift.Type.STRUCT);
    input.readMessageEnd();
    var x = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN_METHOD, 'Unknown function ' + r.fname);
    output.writeMessageBegin(r.fname, Thrift.MessageType.EXCEPTION, r.rseqid);
    x.write(output);
    output.writeMessageEnd();
    output.flush();
  }
}
;
ThriftFileSystemServiceProcessor.prototype.process_watch = function(seqid, input, output) {
  var args = new ThriftFileSystemService_watch_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.watch.length === 2) {
    Q.fcall(this._handler.watch.bind(this._handler), args.uri, args.options)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_watch_result({success: result});
        output.writeMessageBegin("watch", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_watch_result(err);
          output.writeMessageBegin("watch", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("watch", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.watch(args.uri, args.options, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_watch_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("watch", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("watch", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_unwatch = function(seqid, input, output) {
  var args = new ThriftFileSystemService_unwatch_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.unwatch.length === 1) {
    Q.fcall(this._handler.unwatch.bind(this._handler), args.watchId)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_unwatch_result({success: result});
        output.writeMessageBegin("unwatch", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_unwatch_result(err);
          output.writeMessageBegin("unwatch", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("unwatch", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.unwatch(args.watchId, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_unwatch_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("unwatch", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("unwatch", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_pollFileChanges = function(seqid, input, output) {
  var args = new ThriftFileSystemService_pollFileChanges_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.pollFileChanges.length === 1) {
    Q.fcall(this._handler.pollFileChanges.bind(this._handler), args.watchId)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_pollFileChanges_result({success: result});
        output.writeMessageBegin("pollFileChanges", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_pollFileChanges_result(err);
          output.writeMessageBegin("pollFileChanges", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("pollFileChanges", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.pollFileChanges(args.watchId, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_pollFileChanges_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("pollFileChanges", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("pollFileChanges", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_stat = function(seqid, input, output) {
  var args = new ThriftFileSystemService_stat_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.stat.length === 1) {
    Q.fcall(this._handler.stat.bind(this._handler), args.uri)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_stat_result({success: result});
        output.writeMessageBegin("stat", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_stat_result(err);
          output.writeMessageBegin("stat", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("stat", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.stat(args.uri, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_stat_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("stat", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("stat", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_lstat = function(seqid, input, output) {
  var args = new ThriftFileSystemService_lstat_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.lstat.length === 1) {
    Q.fcall(this._handler.lstat.bind(this._handler), args.uri)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_lstat_result({success: result});
        output.writeMessageBegin("lstat", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_lstat_result(err);
          output.writeMessageBegin("lstat", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("lstat", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.lstat(args.uri, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_lstat_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("lstat", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("lstat", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_readDirectory = function(seqid, input, output) {
  var args = new ThriftFileSystemService_readDirectory_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.readDirectory.length === 1) {
    Q.fcall(this._handler.readDirectory.bind(this._handler), args.uri)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_readDirectory_result({success: result});
        output.writeMessageBegin("readDirectory", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_readDirectory_result(err);
          output.writeMessageBegin("readDirectory", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("readDirectory", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.readDirectory(args.uri, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_readDirectory_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("readDirectory", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("readDirectory", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_createDirectory = function(seqid, input, output) {
  var args = new ThriftFileSystemService_createDirectory_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.createDirectory.length === 1) {
    Q.fcall(this._handler.createDirectory.bind(this._handler), args.uri)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_createDirectory_result({success: result});
        output.writeMessageBegin("createDirectory", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_createDirectory_result(err);
          output.writeMessageBegin("createDirectory", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("createDirectory", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.createDirectory(args.uri, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_createDirectory_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("createDirectory", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("createDirectory", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_readFile = function(seqid, input, output) {
  var args = new ThriftFileSystemService_readFile_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.readFile.length === 1) {
    Q.fcall(this._handler.readFile.bind(this._handler), args.uri)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_readFile_result({success: result});
        output.writeMessageBegin("readFile", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_readFile_result(err);
          output.writeMessageBegin("readFile", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("readFile", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.readFile(args.uri, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_readFile_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("readFile", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("readFile", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_writeFile = function(seqid, input, output) {
  var args = new ThriftFileSystemService_writeFile_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.writeFile.length === 3) {
    Q.fcall(this._handler.writeFile.bind(this._handler), args.uri, args.content, args.options)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_writeFile_result({success: result});
        output.writeMessageBegin("writeFile", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_writeFile_result(err);
          output.writeMessageBegin("writeFile", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("writeFile", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.writeFile(args.uri, args.content, args.options, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_writeFile_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("writeFile", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("writeFile", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_deletePath = function(seqid, input, output) {
  var args = new ThriftFileSystemService_deletePath_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.deletePath.length === 2) {
    Q.fcall(this._handler.deletePath.bind(this._handler), args.uri, args.options)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_deletePath_result({success: result});
        output.writeMessageBegin("deletePath", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_deletePath_result(err);
          output.writeMessageBegin("deletePath", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("deletePath", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.deletePath(args.uri, args.options, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_deletePath_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("deletePath", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("deletePath", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_rename = function(seqid, input, output) {
  var args = new ThriftFileSystemService_rename_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.rename.length === 3) {
    Q.fcall(this._handler.rename.bind(this._handler), args.oldUri, args.newUri, args.options)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_rename_result({success: result});
        output.writeMessageBegin("rename", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_rename_result(err);
          output.writeMessageBegin("rename", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("rename", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.rename(args.oldUri, args.newUri, args.options, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_rename_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("rename", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("rename", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
ThriftFileSystemServiceProcessor.prototype.process_copy = function(seqid, input, output) {
  var args = new ThriftFileSystemService_copy_args();
  args.read(input);
  input.readMessageEnd();
  if (this._handler.copy.length === 3) {
    Q.fcall(this._handler.copy.bind(this._handler), args.source, args.destination, args.options)
      .then(function(result) {
        var result_obj = new ThriftFileSystemService_copy_result({success: result});
        output.writeMessageBegin("copy", Thrift.MessageType.REPLY, seqid);
        result_obj.write(output);
        output.writeMessageEnd();
        output.flush();
      }, function (err) {
        var result;
        if (err instanceof ttypes.Error) {
          result = new ThriftFileSystemService_copy_result(err);
          output.writeMessageBegin("copy", Thrift.MessageType.REPLY, seqid);
        } else {
          result = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
          output.writeMessageBegin("copy", Thrift.MessageType.EXCEPTION, seqid);
        }
        result.write(output);
        output.writeMessageEnd();
        output.flush();
      });
  } else {
    this._handler.copy(args.source, args.destination, args.options, function (err, result) {
      var result_obj;
      if ((err === null || typeof err === 'undefined') || err instanceof ttypes.Error) {
        result_obj = new ThriftFileSystemService_copy_result((err !== null || typeof err === 'undefined') ? err : {success: result});
        output.writeMessageBegin("copy", Thrift.MessageType.REPLY, seqid);
      } else {
        result_obj = new Thrift.TApplicationException(Thrift.TApplicationExceptionType.UNKNOWN, err.message);
        output.writeMessageBegin("copy", Thrift.MessageType.EXCEPTION, seqid);
      }
      result_obj.write(output);
      output.writeMessageEnd();
      output.flush();
    });
  }
};
